import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.List; 

public class Arm extends PhysicBarriers
{
    private GreenfootImage image = new GreenfootImage("c_arm.png");

    public Arm()
    {
        setImage(image);
    }

    public void mirror()
    {
        image.mirrorHorizontally();
    }

    public double getX2(){
        return getExactX();
    }

    public double getY2(){
        return getExactY();
    }

    public void setLoc(double x, double y){
        super.setLocation(x, y);
    }

    public void moveItem(boolean a, boolean b)
    {
        List<Weapons> l = getObjectsInRange(50,Weapons.class);
        Weapons w =(Weapons) l.get(0);
        if(a)
        {
            w.getImage().mirrorHorizontally();
        }
    }
    public boolean touchingEnemy(){
        return isTouching(HostilePhys.class);
    }
}
