import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.List;

public class Buttons extends Actor
{
    private String image;
    public Buttons (String bild) {
        setImage(new GreenfootImage(bild));
        image = bild;
    }
        
    public void mousehover() {
        if(Greenfoot.getMouseInfo() != null) {
            if(Greenfoot.getMouseInfo().getActor() == this) {
                switch(image) {
                    case "h_menu_spielen.png" : setImage(new GreenfootImage("h_menu_spielen_hover.png")); image = "h_menu_spielen_hover.png"; break;
                    case "h_menu_optionen.png" : setImage(new GreenfootImage("h_menu_optionen_hover.png")); image = "h_menu_optionen_hover.png"; break;
                    case "h_menu_exit.png" : setImage(new GreenfootImage("h_menu_exit_hover.png")); image = "h_menu_exit_hover.png"; break;
                    case "h_menu_steuerung.png" : setImage(new GreenfootImage("h_menu_steuerung_hover.png")); image = "h_menu_steuerung_hover.png"; break;
                    case "h_menu_credits.png" : setImage(new GreenfootImage("h_menu_credits_hover.png")); image = "h_menu_credits_hover.png"; break;
                    case "h_menu_spielelemente.png" : setImage(new GreenfootImage("h_menu_spielelemente_hover.png")); image = "h_menu_spielelemente_hover.png"; break;
                    case "h_menu_zurück.png" : setImage(new GreenfootImage("h_menu_zurück_hover.png")); image = "h_menu_zurück_hover.png"; break;
                    case "h_menu_arrow.png" : setImage(new GreenfootImage("h_menu_arrow_hover.png")); image = "h_menu_arrow_hover.png"; break;
                    case "h_menu_arrow_right.png" : setImage(new GreenfootImage("h_menu_arrow_right_hover.png")); image = "h_menu_arrow_right_hover.png"; break;
                    case "h_levelauswahl_zurück.png" : setImage(new GreenfootImage("h_levelauswahl_zurück_hover.png")); image = "h_levelauswahl_zurück_hover.png"; break;
                    case "h_menu_endless.png" : setImage(new GreenfootImage("h_menu_endless_hover.png")); image = "h_menu_endless_hover.png"; break;
                    case "h_menu_story.png" :setImage(new GreenfootImage("h_menu_story_hover.png")); image = "h_menu_story_hover.png"; break;
                    
                    case "h_menu_arrow - Elements.png" : setImage(new GreenfootImage("h_menu_arrow_hover - Elements.png")); image = "h_menu_arrow_hover - Elements.png"; break;
                    case "h_menu_arrow_right - Elements.png" : setImage(new GreenfootImage("h_menu_arrow_right_hover - Elements.png")); image = "h_menu_arrow_right_hover - Elements.png"; break;
                    
                    default : break;
                }
            }
            
            if(((Greenfoot.getMouseInfo().getX() > (this.getX()+30)) | (Greenfoot.getMouseInfo().getX() < (this.getX()-30)))
             && ((Greenfoot.getMouseInfo().getY() > (this.getY()+15)) | (Greenfoot.getMouseInfo().getY() < (this.getY()-15)))) {
                 switch(image) {
                    case "h_menu_spielen_hover.png" : setImage(new GreenfootImage("h_menu_spielen.png")); image = "h_menu_spielen.png"; break;
                    case "h_menu_optionen_hover.png" : setImage(new GreenfootImage("h_menu_optionen.png")); image = "h_menu_optionen.png"; break;
                    case "h_menu_exit_hover.png" : setImage(new GreenfootImage("h_menu_exit.png")); image = "h_menu_exit.png"; break;
                    case "h_menu_steuerung_hover.png" : setImage(new GreenfootImage("h_menu_steuerung.png")); image = "h_menu_steuerung.png"; break;
                    case "h_menu_credits_hover.png" : setImage(new GreenfootImage("h_menu_credits.png")); image = "h_menu_credits.png"; break;
                    case "h_menu_spielelemente_hover.png" : setImage(new GreenfootImage("h_menu_spielelemente.png")); image = "h_menu_spielelemente.png"; break;
                    case "h_menu_zurück_hover.png" : setImage(new GreenfootImage("h_menu_zurück.png")); image = "h_menu_zurück.png"; break;
                    case "h_menu_arrow_hover.png" : setImage(new GreenfootImage("h_menu_arrow.png")); image = "h_menu_arrow.png"; break;
                    case "h_menu_arrow_right_hover.png" : setImage(new GreenfootImage("h_menu_arrow_right.png")); image = "h_menu_arrow_right.png"; break;
                    case "h_levelauswahl_zurück_hover.png" : setImage(new GreenfootImage("h_levelauswahl_zurück.png")); image = "h_levelauswahl_zurück.png"; break;
                    case "h_menu_endless_hover.png" : setImage(new GreenfootImage("h_menu_endless.png")); image = "h_menu_endless.png"; break;
                    case "h_menu_story_hover.png" : setImage(new GreenfootImage("h_menu_story.png")); image = "h_menu_story.png"; break;
                    
                    case "h_menu_arrow_hover - Elements.png" : setImage(new GreenfootImage("h_menu_arrow - Elements.png")); image = "h_menu_arrow - Elements.png"; break;
                    case "h_menu_arrow_right_hover - Elements.png" : setImage(new GreenfootImage("h_menu_arrow_right - Elements.png")); image = "h_menu_arrow_right - Elements.png"; break;
                    default: break;
                }
            }
        }
    }
    
    public void mouseclick() {
        sounds s = null;
        if(Greenfoot.mouseClicked(this)) {
            switch (image) {
                case "h_menu_spielen_hover.png" : List<sounds> l = getWorld().getObjects(sounds.class);
                                                   s = (sounds) l.get(0);
                                                   s.menuStopp();
                                                   Greenfoot.setWorld(new ShipWorld());
                                                   break;
                case "h_menu_optionen_hover.png" : Greenfoot.setWorld(new Options()) ; break;
                case "h_menu_exit_hover.png" : Greenfoot.stop(); System.exit(0); break;
                case "h_menu_steuerung_hover.png" : Greenfoot.setWorld(new ControlWorld()); break;
                case "h_menu_credits_hover.png" : Greenfoot.setWorld(new Credits()); break;
                case "h_menu_spielelemente_hover.png" : Greenfoot.setWorld(new Elements()); break;
                case "h_menu_zurück_hover.png" : zurück(); break;
                case "h_menu_arrow_hover.png" : arrow();break;
                case "h_menu_arrow_right_hover.png" : arrow(); break;
                case "h_menu_story_hover.png" : Greenfoot.setWorld(new Level1_1());break;
                case "h_menu_endless_hover.png" : Greenfoot.setWorld(new Endless()); break;
                case "h_levelauswahl_zurück_hover.png" : Greenfoot.setWorld(new ShipWorld());break;
                
                case "h_menu_arrow_hover - Elements.png" : Greenfoot.setWorld( new Elements());break;
                case "h_menu_arrow_right_hover - Elements.png" : Greenfoot.setWorld( new Elements2()); break;
                
                default: break;
            }
        }
    }
    
    private void zurück() {
        switch (this.getY()) {
            case 576 : Greenfoot.setWorld(new Menu()); break;
            case 540 : Greenfoot.setWorld(new Options()); break;
            default : break;
        }
    }
    
    private void arrow() {
        switch(this.getY()) {
            case 358 :  Greenfoot.setWorld(new Credits()); break;
            case 359 : Greenfoot.setWorld(new Credits2()); break;
            case 360 : Greenfoot.setWorld(new Tips()); break;
            case 361 : Greenfoot.setWorld(new ControlWorld()); break;
        }
    }
    
    private void ship() {
        if(image == "h_ship_blue_HD.png") {
            if(/* der steht da && */ Greenfoot.isKeyDown("O")) {
                Greenfoot.setWorld(new Options());
            }
            if(/* der steht da && */ Greenfoot.isKeyDown("P")) {
                Greenfoot.setWorld(new Storylevel()); //oder new Endless??
            }
        }
    }

    public String returnImage() {
        return image;
    }
    public void act() 
    {
        mouseclick();
        mousehover();
        ship();
    }       
}
