import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.io.*;
import java.util.List;
/**
 * Write a description of class Heroes here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class HeroesPhys extends SmoothMover

{
    //Links - Rechts

    private double speed;
    private double currentSpeed;
    private double maxSpeed;

    private int direction;
    private int dirAlt;
    private double armDrehWinkel;

    private double exelaration;

    private double x;
    private double y;

    private int playerheight = 64;

    private int playerwidth = 32;

    //Hoch - Runter
    private double jumpHeight;
    private double currentJumpHeight;

    private double jumpSmoothener;

    private double gravity;
    private double currentGravity;

    private int jumpTimer;
    private int JumpExitTimer;
    private int runTimer;

    private boolean preventJumping;
    private boolean inAir;
    private boolean firstAct;
    private boolean resetSpeed;

    private GreenfootImage steponel;
    private GreenfootImage steptwol;
    private GreenfootImage stepthreel;
    private GreenfootImage steponer;
    private GreenfootImage steptwor;
    private GreenfootImage stepthreer;
    private GreenfootImage standr;
    private GreenfootImage standl;

    private Left l;
    private Right r;
    private Bottom b;
    private Top t;
    
    private Barriere RU;
    private Barriere RO;
    private Barriere LU;
    private Barriere LO;
    
    private Barriere O;
        
    //Arm & Armbewegung
    private Arm a;
    private double aBw = 5.0;
    private boolean mirrored = false;
    private boolean iDr = false;

    private int attackTimer = 0;
    private boolean attack = false;
    private boolean dmgDealt = false;
    private boolean directionChanged = false;
    private boolean directionChangedA = false;
    private int timerPistole = 0;
    private int timerR = 0;
    private int staminaVerbrauch = 0;
    
    private boolean waffeSpiegeln = false;
    public HeroesPhys(){
        speed = 4.0;
        maxSpeed = 9.0; 
        exelaration = 0.2; 
        direction = 1;

        jumpHeight = 28;
        currentJumpHeight = jumpHeight;
        jumpSmoothener = 0.8;

        gravity = 12;
        currentGravity = gravity;

        jumpTimer = 200000;

        firstAct = true;
        preventJumping = true;

        jumpTimer = 10000;
        runTimer = 0;
        l = new Left();
        r = new Right();
        b = new Bottom();
        t = new Top();
        a = new Arm();
        RO = new Barriere(1,60);
        RU = new Barriere(1,5);
        LO = new Barriere(1,60);
        LU = new Barriere(1,5);
        O = new Barriere(40,1);
        steponel= new GreenfootImage("c_moving_left_a_1.png");
        steptwol= new GreenfootImage("c_moving_left_a_2.png");
        stepthreel= new GreenfootImage("c_moving_left_a_3.png");
        steponer= new GreenfootImage("c_moving_right_a_1.png");
        steptwor= new GreenfootImage("c_moving_right_a_2.png");
        stepthreer= new GreenfootImage("c_moving_right_a_3.png");
        standr= new GreenfootImage("c_standing_look_right_noarm.png");
        standl= new GreenfootImage("c_standing_look_left_noarm.png");
        setImage(standr);
    }

    public void act(){

        if(firstAct){
            
            World w = getWorld();

            w.addObject(l, getX() - 17, getY());
            w.addObject(r, getX() + 17, getY());
            w.addObject(t, getX(), getY() - 33);
            w.addObject(b, getX(), getY() + 30);
            w.addObject(RO, getX() + 20, getY() - 20);
            w.addObject(RU, getX() + 20, getY() + 20);
            w.addObject(LO, getX() - 20, getY() - 20);
            w.addObject(LU, getX() - 20, getY() + 20);
             w.addObject(O, getX(), getY() - 40);
            w.addObject(a,getX(),getY());
            if(getWeapon() != null && direction < 0){
                getWeapon().mirror();
            }
            firstAct = false;
        }
        else{
            checkGround();
            setDircetion();

            startJump();
            moveUpDown(jumpHeight());
            
            blockWalk();
            moveBarriers();
            
            armMitMausSteuerung();
            jumpTimer++;
            timerP();
            timerR();
            if(waffeSpiegeln){
                getWeapon().mirror();
                waffeSpiegeln = false;
            }
        }
    }
    
    public void setWaffeSpiegeln(boolean b){
        waffeSpiegeln = b;
    }
    
    public boolean getWaffeSpiegeln(){
        return waffeSpiegeln;
    }
    
    public double getspeed(){
        return speed;
    }

    public void setspeed(double speed){
        this.speed=speed;
    }

    public double getmaxspeed(){
        return maxSpeed;
    }

    public void setmaxspeed(double maxspeed){
        this.maxSpeed=maxspeed;
    }

    public int getDirection(){
        return direction;
    }
    
    public boolean getDirectionChanged(){
        return directionChangedA;
    }
    
    private void blockWalk(){
        if(RU.touching()&& !RO.touching() && !O.touching() && Greenfoot.isKeyDown("D") && !Greenfoot.isKeyDown("A")){
            super.setLocation(getExactX() + 3.0, getExactY() - 22);
        }
        if(LU.touching()&& !LO.touching() && !O.touching() && Greenfoot.isKeyDown("A") && !Greenfoot.isKeyDown("D")){
            super.setLocation(getExactX() - 3.0, getExactY() - 22);
        }
    }
    private void setDircetion(){
        MouseInfo m = Greenfoot.getMouseInfo();
        dirAlt = direction;
        if(m != null){
            if(m.getX() > 1280/2){
                direction = 1;
                if(direction != dirAlt){
                    directionChanged = true;
                    directionChangedA = true;
                }
                else
                {
                    directionChangedA = false;
                }
           }
            else{
                direction = -1;
                if(direction != dirAlt){
                    directionChanged = true;
                    directionChangedA = true;
                }
                else
                {
                    directionChangedA = false;
                }
            }
        }
    }

    public void exelarate()
    {
        if(currentSpeed < maxSpeed){
            currentSpeed = currentSpeed + exelaration * currentSpeed;
        }
        else{
            currentSpeed = maxSpeed;
        }
    }

    public double get_X(){
        return x;
    }

    public double get_Y(){
        return y;
    }

    public void setLocation()

    {
        x = this.getX();
        y = this.getY();
    }

    public double moveHorizontal(){
        double move = 0;
        if(Greenfoot.isKeyDown("D") && !Greenfoot.isKeyDown("A"))
        {
            exelarate();
            runTimer++;
            for(double i = 0;i <= currentSpeed; i = i+ 0.1){
                r.setLoc(r.getX2()+0.1,getY());
                if(r.touching()){
                    currentSpeed = i;
                    resetSpeed = true;
                }
                if(!(r.touching()) && resetSpeed){
                    resetSpeed = false;
                    currentSpeed = speed;
                }
            } 
            move = currentSpeed;
            changeDirection("D");
        }

        if(Greenfoot.isKeyDown("A") && !Greenfoot.isKeyDown("D"))
        {
            exelarate();
            runTimer++;
            for(double y= 0 ; y<= currentSpeed; y= y+0.1)
            {
                l.setLoc(l.getX2()-0.1,getExactY());
                if(l.touching())
                {
                    currentSpeed = y;
                    resetSpeed = true;
                }
                if(!(l.touching()) && resetSpeed){
                    resetSpeed = false;
                    currentSpeed = speed;
                }
            }
            move = -currentSpeed;
            changeDirection("A");
        }

        
        if(!(Greenfoot.isKeyDown("D")) && !(Greenfoot.isKeyDown("A")) || (Greenfoot.isKeyDown("D") && Greenfoot.isKeyDown("A"))){
            currentSpeed = speed;
            runTimer = 0;
            if(direction > 0){
                setImage(standr);
                if (mirrored)
                {
                    a.mirror();
                    if(getWeapon() != null){
                        getWeapon().mirror();
                    }
                    mirrored = false;

                }
                aBw = 5.0;
            }
            if(direction < 0){
                setImage(standl);
                if (!mirrored)
                {
                    a.mirror();
                    if(getWeapon() != null){
                        getWeapon().mirror();
                    }
                    mirrored = true;

                }
                aBw = -5.0;
            }

        }
        return move;
    }

    private void changeDirection(String key){
        switch(runTimer){
            case 0 :
            case 1 :
            case 2 :
            case 3 :
            case 4 :
            case 5 :
            case 6 :
            case 7 :
            case 8 :
            case 9 :
            case 10 :
            case 11 :
            case 12 :
            case 13 :
            case 14 :
            case 15 : 
            if(direction > 0 && (dirAlt != direction || runTimer == 0)){
                if(key == "D"){
                    setImage(steponer);
                }
                if(key == "A"){
                    setImage(stepthreer);
                }
                if (mirrored)
                {
                    a.mirror();
                    if(getWeapon() != null){
                        getWeapon().mirror();
                    }
                    mirrored = false;
                }
                aBw = 1.0;

            }
            if(direction < 0 && (dirAlt != direction || runTimer == 0)){
                if(key == "D"){
                    setImage(stepthreel);
                }
                if(key == "A"){
                    setImage(steponel);
                }
                if (!mirrored)
                {
                    aBw = 0.0;
                    a.mirror();
                    if(getWeapon() != null){
                        getWeapon().mirror();
                    }
                    mirrored = true;
                }

            }
            break;
            case 16 :
            case 17 :
            case 18 :
            case 19 :
            case 20 :
            case 21 :
            case 22 :
            case 23 :
            case 24 :
            case 25 :
            case 26 :
            case 27 :
            case 28 :
            case 29 :
            case 30 :
            if(direction > 0 && (dirAlt != direction || runTimer == 16)){
                setImage(steptwor);
                if (mirrored)
                {
                    a.mirror();
                    if(getWeapon() != null){
                        getWeapon().mirror();
                    }
                    mirrored = false;
                }
                aBw = 1.0;

            }
            if(direction < 0 && (dirAlt != direction || runTimer == 16)){
                setImage(steptwol);
                if (!mirrored)
                {
                    aBw = 0.0;
                    a.mirror();
                    if(getWeapon() != null){
                        getWeapon().mirror();
                    }
                    mirrored = true;
                }

            }
            break;
            case 31 :
            case 32 :
            case 33 :
            case 34 :
            case 35 :
            case 36 :
            case 37 :
            case 38 :
            case 39 :
            case 40 :
            case 41 :
            case 42 :
            case 43 :
            case 44 :
            case 45 :
            if(direction > 0 && (dirAlt != direction || runTimer == 31)){
                if(key == "D"){
                    setImage(stepthreer);
                }
                if(key == "A"){
                    setImage(steponer);
                }
                if (mirrored)
                {
                    a.mirror();
                    if(getWeapon() != null){
                        getWeapon().mirror();
                    }
                    mirrored = false;
                }
                aBw = 1.0;

            }
            if(direction < 0 && (dirAlt != direction || runTimer == 31)){
                if(key == "D"){
                    setImage(steponel);
                }
                if(key == "A"){
                    setImage(stepthreel);
                }
                if (!mirrored)
                {
                    aBw = 0.0;
                    a.mirror();
                    if(getWeapon() != null){
                        getWeapon().mirror();
                    }
                    mirrored = true;
                }
            }
            if(runTimer == 45){
                runTimer = -1;
            }
            break;
        }

    }

    // Up - Down
    public void startJump(){
        if(Greenfoot.isKeyDown("Space") && !preventJumping){
            jumpTimer = 0;
            preventJumping = true;
            inAir = true;
        }
    }
    
    public double jumpHeight(){

        if((currentJumpHeight  - (jumpSmoothener * jumpTimer)) > - 10 ){
            return (currentJumpHeight  - (jumpSmoothener * jumpTimer));
        }
        else{
            return 0;
        }
    }

    public void moveUpDown(double jump){
        double moveUD = currentGravity - jump;

        if(moveUD > 0 && inAir){
            double i = 0;
            while(i < moveUD){
                b.setLoc(b.getX2(),b.getY2() + 0.1);
                if(b.touching()){
                    moveUD = i;
                    checkGround();
                }
                i = i+ 0.1;

            }
        }
        if(moveUD < 0 && inAir){
            double i = 0;
            while(i > moveUD){
                t.setLoc(t.getX2(),t.getY2() - 0.1);
                if(t.touching()){
                    moveUD = i;
                    jumpTimer = 1000000;
                }
                i = i- 0.1;

            }
        }
        super.setLocation(getExactX(),getExactY() + moveUD);
        t.setLoc(getExactX(), getExactY() + 33.0);

    }
    // Gravitation
    public void checkGround(){

        if(b.touching()){
            currentGravity = 0;
            inAir = false;
            preventJumping = false;
        } 
        else{
            currentGravity = gravity;
            inAir = true;
        }

    }

    public GreenfootImage getImages()
    {
        return this.getImage();
    }
    // Physik Barrieren

    public void moveBarriers(){
        l.setLocation(getX() - 17.0, getY());
        r.setLocation(getX() + 17.0, getY());
        t.setLocation(getX(), getY() - 33.0);
        b.setLoc(getExactX(), getExactY() + 30.0);
        
        RO.setLocation(getX() + 20, getY() - 20);
        RU.setLocation(getX() + 20, getY() + 20);
        LO.setLocation(getX() - 20, getY() - 20);
        LU.setLocation(getX() - 20, getY() + 20);
        O.setLocation(getX(), getY() - 40);
        
        a.setLoc(getExactX()+aBw, getExactY() - 4.0);
    }
    //ARMOFDOOM
    private void armRotieren(double drehenUm){
        a.turn((int) (drehenUm - a.getRotation()) );
    }

    public void armMitMausSteuerung(){
        //Arm xPos und yPos
        double ax,ay;
        //Maus xPos und yPos
        double mx,my;
        //Delta-X und Delta-Y
        double dx,dy;

        ax = a.getX2();
        ay = a.getY2();
        if(Greenfoot.getMouseInfo() != null){
                mx = Greenfoot.getMouseInfo().getX();
                my = Greenfoot.getMouseInfo().getY();
            }
            else{
                mx = ax + 10;
                my = ay;
            }    
            dx = mx - ax;
            dy = my - ay;
        if((Greenfoot.mouseClicked(null) || attack) && getWeapon() != null){
            attack(dx,dy);
        }
        else{
            
            if(!(dx < 5 && dx > -5)){
                armDrehWinkel = Math.toDegrees(Math.atan(dy/dx));
                armRotieren(armDrehWinkel);
            }
            else{
                if( (dy > 0 && direction > 0) || (dy < 0 && direction < 0 ) ){
                    armDrehWinkel = 90;
                    armRotieren(armDrehWinkel);
                }
                if( (dy > 0 && direction < 0) || (dy < 0 && direction > 0 ) ){
                    armDrehWinkel = -90;
                    armRotieren(armDrehWinkel);
                }

            }
            moveAandW(ax,ay);
        }
    }
    //Item in der Hand mitbewegen
    public void moveAandW(double ax, double ay){
        List<Weapons> l = getWorld().getObjects(Weapons.class);
        Weapons w = null;
        //Arm-Länge
        double aRadius = 22.0;
        //Delta-X und Delta-Y des Armes

        double dx,dy;
        //Delta-X und Delta-Y der Waffe
        double dx2,dy2;
        //Waffenlänge
        double wRadius;
        // Mittelpunkt der Waffe
        int wPx,wPy;

        //Position der Hand
        int hx,hy;

        for (int i = 0; i < l.size(); i = i+1)
        {
            if (l.get(i).statusGeben() == 1)
            {
                w = (Weapons) l.get(i);
            }
        }

        if(w != null)
        {

            dy =  Math.sin(Math.toRadians(armDrehWinkel)) * aRadius;
            dx =  Math.cos(Math.toRadians(armDrehWinkel)) * aRadius;
            hx = (int) (ax + (direction * dx));
            hy = (int) (ay + (direction * dy));

            //Berechnung der Waffenposition
            wRadius = Math.sqrt(( (w.getWidth() - aRadius) * (w.getWidth() - aRadius)+ w.getHeight()*w.getHeight()));

            dx2 = Math.sin(Math.toRadians(armDrehWinkel)) * wRadius;
            dy2 = Math.cos(Math.toRadians(armDrehWinkel)) * wRadius;

            if(w instanceof Melee){
                w.turn((int) ( (armDrehWinkel)) - w.getRotation() - 45*direction );
                wPx = (int) (hx + dx2);
                wPy = (int) (hy - dy2);
                w.verschieben(wPx,wPy);
            }
            else{
                w.turn((int) (armDrehWinkel) - w.getRotation());
                wPx = (int) (hx + dx2);
                wPy = (int) (hy - dy2);
                w.verschieben(wPx,wPy);
            }
        }
    }

    private void attack(double dx, double dy){
        attack = true;
        if(directionChanged){
            armDrehWinkel = -armDrehWinkel;
            directionChanged = false;
        }
        if(getWeapon() instanceof Melee || getWeapon() == null)
        {
            if(direction < 0){
                if(attackTimer < 11){
                    armDrehWinkel = armDrehWinkel + 8;
                    armRotieren(armDrehWinkel);
                    moveAandW(a.getX2(),a.getY2());
                    
                    attackTimer++;
                }
                if(attackTimer >= 11 && attackTimer < 33){
                    armDrehWinkel = armDrehWinkel - 8;
                    armRotieren(armDrehWinkel);
                    moveAandW(a.getX2(),a.getY2());
                    if(getWeapon() != null){
                        if(getWeapon().touchingEnemy() && !dmgDealt){
                            List<HostilePhys> hostilePhys = getWorld().getObjects(HostilePhys.class);
                            HostilePhys h = null;
                            for(int i = 0; i < hostilePhys.size(); i++){
                                if(hostilePhys.get(i).touchingWeapon()){
                                    h =  hostilePhys.get(i);
                                    dmgDealt = true;
                                }
                            }
                            h.setHealth(h.getHealth() - getWeapon().getDamage());
                        }
                    }
                    if(a.touchingEnemy() && !dmgDealt){
                        List<HostilePhys> hostilePhys = getWorld().getObjects(HostilePhys.class);
                        HostilePhys h = null;
                        for(int i2 = 0; i2 < hostilePhys.size(); i2++){
                            if(hostilePhys.get(i2).touchingWeapon()){
                                h =  hostilePhys.get(i2);
                                dmgDealt = true;
                            }
                        }
                        h.setHealth(h.getHealth() - 4);
                    }
                    attackTimer++;
                }
                if(attackTimer >= 33 && attackTimer < 44){
                    dmgDealt = false;
                    armDrehWinkel = armDrehWinkel + 8;
                    armRotieren(armDrehWinkel);
                    moveAandW(a.getX2(),a.getY2());

                    attackTimer++;
                }
                if(attackTimer >= 44){
                    attackTimer = 0;
                    attack = false;
                    dmgDealt = false;
                }
            }
            else{
                if(attackTimer < 11){
                    armDrehWinkel = armDrehWinkel - 8;
                    armRotieren(armDrehWinkel);
                    moveAandW(a.getX2(),a.getY2());

                    attackTimer++;
                }
                if(attackTimer >= 11 && attackTimer < 33){
                    armDrehWinkel = armDrehWinkel + 8;
                    armRotieren(armDrehWinkel);
                    moveAandW(a.getX2(),a.getY2());
                    if(getWeapon().touchingEnemy() && !dmgDealt){
                        List<HostilePhys> hostilePhys = getWorld().getObjects(HostilePhys.class);
                        HostilePhys h = null;
                        for(int i = 0; i < hostilePhys.size(); i++){
                            if(hostilePhys.get(i).touchingWeapon()){
                                h =  hostilePhys.get(i);
                                dmgDealt = true;
                            }
                        }
                        h.setHealth(h.getHealth() - getWeapon().getDamage());
                    }
                    attackTimer++;
                }
                if(attackTimer >= 33 && attackTimer < 44){
                    dmgDealt = false;
                    armDrehWinkel = armDrehWinkel - 8;
                    armRotieren(armDrehWinkel);
                    moveAandW(a.getX2(),a.getY2());

                    attackTimer++;
                }
                if(attackTimer >= 44){
                    attackTimer = 0;
                    attack = false;
                    dmgDealt = false;
                }
            }        
        }
        else{
            if(getWorld().getObjects(Player.class).get(0).getstamina() > 0){
                if(Greenfoot.mouseClicked(null))
                {
                    if( getWeapon() instanceof Pistole && timerPistole >=120)
                    {
                      getWorld().addObject(new Projectile(a.getRotation(), direction),a.getX(),a.getY());                
                      timerPistole = 0;
                      staminaVerbrauch = staminaVerbrauch + 3;
                     }
                     if( getWeapon() instanceof MP)
                    {
                      getWorld().addObject(new Projectile(a.getRotation(), direction),a.getX(),a.getY());                
                      staminaVerbrauch = staminaVerbrauch + 3;
                     }
                    if( getWeapon() instanceof Revolver && timerR >=500)
                    {
                        getWorld().addObject(new ProjectileR(a.getRotation(), direction),a.getX(),a.getY());                
                        timerR= 0;
                        staminaVerbrauch = staminaVerbrauch + 8;
                    }
                    if( getWeapon() instanceof DMR && timerR >=200)
                    {
                        getWorld().addObject(new ProjectileR(a.getRotation(), direction),a.getX(),a.getY());                
                        timerR= 0;
                        staminaVerbrauch = staminaVerbrauch + 8;
                    }
                    if( getWeapon() instanceof LMG && timerR >=60)
                    {
                        getWorld().addObject(new ProjectileR(a.getRotation(), direction),a.getX(),a.getY());                
                        timerR= 0;
                        staminaVerbrauch = staminaVerbrauch + 8;
                    }
                    if( getWeapon() instanceof Sturmgewehr )
                    {
                        getWorld().addObject(new ProjectileR(a.getRotation(), direction),a.getX(),a.getY());                
                        timerR= 0;
                    }
                    if( getWeapon() instanceof Katzenwerfer && timerR >70)
                    {
                        getWorld().addObject(new Katze(a.getRotation(), direction),a.getX(),a.getY());                
                        timerR= 0;
                        staminaVerbrauch = staminaVerbrauch + 20;
                    }
                    if( getWeapon() instanceof Laserrifle && timerR >70)
                    {
                        getWorld().addObject(new Laser(a.getRotation(), direction),a.getX(),a.getY());                
                        timerR= 0;
                        staminaVerbrauch = staminaVerbrauch + 5;
                    }
                    if( getWeapon() instanceof RPG && timerR >70)
                    {
                        getWorld().addObject(new Rakete(a.getRotation(), direction),a.getX(),a.getY());                
                        timerR= 0;
                        staminaVerbrauch = staminaVerbrauch + 10;
                    }
                        attack = false;
                }
                while(staminaVerbrauch >= 10){
                    staminaVerbrauch = staminaVerbrauch - 10;
                    if(getWorld().getObjects(Player.class).get(0).getstamina() > 0){
                        int i = getWorld().getObjects(Player.class).get(0).getstamina();
                        getWorld().getObjects(Player.class).get(0).setstamina(i - 1);
                    }
                }
            }
        }
    }
    
    public void timerP()
    {
        timerPistole++;
        if( timerPistole == 120|| timerPistole == 121)
        {
            timerPistole = 120;
        }
    }
    
     public void timerR()
    {
        timerR++;
        if( timerR == 500 || timerR == 501)
        {
            timerPistole = 500;
        }
    }

    private Weapons getWeapon(){
        List<Weapons> l = getWorld().getObjects(Weapons.class);
        Weapons w = null;
        for (int i = 0; i < l.size(); i = i+1)
        {
            if (l.get(i).statusGeben() == 1)
            {
                w = (Weapons) l.get(i);
            }
        }
        return w;
    }

    public void setFirstAct()
    {
        firstAct = true;
    }
}