import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

public class Background extends Objects
{
    private GreenfootImage object;
    private int width = 0; //1/2 * Bildbreite - Fußpunkt der Grafik
    private int height = 0; // height/2;
    public Background(int objectnumber){
        switch(objectnumber){
            case 0 : object = new GreenfootImage("g_desert_grass.png"); break;
            case 1 : object = new GreenfootImage("g_desert_grass_small.png"); break;
            case 2 : object = new GreenfootImage("g_purple_grass.png"); break;
            
            case 3 : object = new GreenfootImage("g_tree_desert.png"); width = 6; height = 99; break;
            case 4 : object = new GreenfootImage("g_tree_desert_2.png"); width = -6; height = 99; break;
            case 5 : object = new GreenfootImage("g_desert_bush.png"); width = -2; height = 19; break;
            case 6 : object = new GreenfootImage("g_desert_bush_2.png"); width = 0; height = 19; break;
            case 7 : object = new GreenfootImage("g_desert_bush_3.png"); width = 2; height = 19; break;
            case 8 : object = new GreenfootImage("g_desert_bush_4.png"); width = 0; height = 19; break;
            
            case 9 : object = new GreenfootImage("g_tree.png"); width = 6; height = 99; break;
            case 10 : object = new GreenfootImage("g_tree_2.png"); width = -6; height = 99; break;
            case 11 : object = new GreenfootImage("g_purple_bush.png"); width = -2; height = 19; break;
            case 12 : object = new GreenfootImage("g_purple_bush_2.png");  width = 0; height = 19; break;
            case 13 : object = new GreenfootImage("g_purple_bush_3.png"); width = -2; height = 19; break;
            case 14 : object = new GreenfootImage("g_purple_bush_4.png");  width = 0; height = 19; break;
            
            case 15 : object = new GreenfootImage("g_chest_large.png"); break;
            case 16 : object = new GreenfootImage("g_chest_small.png"); break;
            case 17 : object = new GreenfootImage("h_tent.png"); break;
            case 18 : object = new GreenfootImage("h_tentold.png"); break;
            case 19 : object = new GreenfootImage("g_tent.png"); break;
            case 20 : object = new GreenfootImage("g_ruine.png"); break;
            case 21 : object = new GreenfootImage("h_baracke.png"); break;
            case 22 : object = new GreenfootImage("h_Skyscraper_high.png"); break;
            case 23 : object = new GreenfootImage("h_schrottauto.png"); break;
            // Freigehalten für weitere Objekte
            case 24 : object = new GreenfootImage(""); break;
            case 25 : object = new GreenfootImage(""); break;
            case 26 : object = new GreenfootImage(""); break;
            case 27 : object = new GreenfootImage(""); break;
            case 28 : object = new GreenfootImage(""); break;
            case 29 : object = new GreenfootImage(""); break;
            case 30 : object = new GreenfootImage("h_weapon_locker.png"); break;
            case 31 : object = new GreenfootImage("h_schrank.png"); break;
            case 32 : object = new GreenfootImage("h_moderndoor_open.png"); break;
            case 33 : object = new GreenfootImage("h_cell_door_bg.png"); break;
            case 34 : object = new GreenfootImage("g_steel_door.png"); break;
            case 35 : object = new GreenfootImage("h_teleportpad.png"); break;
            case 36 : object = new GreenfootImage("h_moderndoor_open.png"); break;
            case 37 : object = new GreenfootImage("g_airlock_open.png"); break;
            case 38 : object = new GreenfootImage("h_table.png"); break;
            case 39 : object = new GreenfootImage("h_chair.png"); break;
            case 40 : object = new GreenfootImage("g_dreiteiligerbildschirm.png"); break;
            case 41 : object = new GreenfootImage("Cardreader (rot).png"); break;
            case 42 : object = new GreenfootImage("g_computer_2.png"); break;
            case 43 : object = new GreenfootImage("g_neonlampe.png"); break;
            case 44 : object = new GreenfootImage("h_locker.png"); break;
            case 45 : object = new GreenfootImage("g_controllpanel_green.png"); break;
            case 46 : object = new GreenfootImage("h_computer2.png"); break;
            case 47 : object = new GreenfootImage(""); break;
            case 48 : object = new GreenfootImage(""); break;
            case 49 : object = new GreenfootImage(""); break;
            case 50 : object = new GreenfootImage(""); break;
        }
        setImage(object);
    }
    public int getWidth(){
        return width;
    }
    public int getHeight(){
        return height;
    }
    public void act() 
    {
        
    }    
}