import greenfoot.*;
import java.io.*;
import java.util.List;
public class Player extends Heroes implements Serializable
{
    private int life;
    private int stamina;
    private boolean schaden=true;
    private boolean ausdauer=true;
    private java.util.List h;
    private java.util.List s;
    private boolean start=true;
    private boolean aenderung=true;
    private int strength; 
    private int timer=0;
    private int wert = 0;
    private int numberhealth=1;
    private int numberstamina=1;
    private int numberspeed=1;
    private int numberaddhealth=1;
    private int numberaddstamina=1;
    private int numberstrength=1;
    private int potiontimer=51;
    private int delay;
    private static final int MAX_DELAY =20;
    
    GreenfootSound heartbeat = new GreenfootSound("Heartbeat.mp3");
    GreenfootSound hitsound = new GreenfootSound("Hitsound.mp3");
    public Player()
    {
        super();
        life = 10+wert;
        stamina = 10;
        strength = 3;
    }
    
    public void healthSetzen(int numberhealth){
        this.numberhealth=numberhealth;
    }
    
    public int healthGeben(){
        return numberhealth;
    }
    
    public void staminaSetzen(int numberstamina){
        this.numberstamina=numberstamina;
    }
    
    public int staminaGeben(){
        return numberstamina;
    }
    
    public void speedSetzen(int numberspeed){
        this.numberspeed=numberspeed;
    }
    
    public int speedGeben(){
        return numberspeed;
    }
    
    public void addhealthSetzen(int numberaddhealth){
        this.numberaddhealth=numberaddhealth;
    }
    
    public int addhealthGeben(){
        return numberaddhealth;
    }
    
    public int addstaminaGeben(){
        return numberaddstamina;
    }
    
    public void addstamiaSetzen(int numberaddstamina){
        this.numberaddstamina=numberaddstamina;
    }
    
    public void strengthSetzen(int numberstrength){
        this.numberstrength=numberstrength;
    }
    
    public int strengthGeben(){
        return numberstrength;
    }

    public int timerGeben(){
        return timer;
    }

    public void timerSetzen(int timer){
        this.timer=timer;
    }

    public void wertSetzen(int wert)
    {
        this.wert = wert;
        lebenSetzen();
    }

    public void lebenSetzen()
    {
        life = life + wert;
    }

    public void aenderungSetzen(){
        aenderung=true;
    }

    public void startSetzen()
    {
        start = true;
    }
    
    public int getstrength(){
        return strength;
    }

    public void setstrength(int strength){
        this.strength=strength;
    }

    public int getlife()
    {
        return life;
    }

    public void setlife(int life)
    {
        this.life = life;
        schaden=true;
    }

    public int getstamina(){
        return stamina;
    }

    public void setstamina(int stamina){
        this.stamina=stamina;
        ausdauer=true;
    }

    // Sobald feindliche Blöcke existieren hier schaden abziehen und statt dangerous Klassenname einfügen
    public void hurtPlayer()
    {
        if(isTouching(Enemy.class)||isTouching(Enemy2.class)||isTouching(Enemy3.class))
        {
            if(delay<MAX_DELAY){
                delay++;
                return;
            }
            else{
                delay =0; 
            }
            if(isTouching(Enemy2.class)||isTouching(Enemy3.class)){
                life = life-1;
            }
            if(isTouching(Enemy.class)){
                life = life-2;
            }
            schaden=true;
            if(!hitsound.isPlaying()){
                hitsound.play();
            }
        }
    }

    public void act()
    {
        super.act();       
        timer--;
        hurtPlayer();
        potiontimer++;
        sounds a = null;
        if(life<=0){
            List<sounds> k = getWorld().getObjects(sounds.class);
            a = (sounds) k.get(0);
            a.endless();
            a.gameover();
            Greenfoot.setWorld(new GameOver());
        }
        
        if(timer==0){
            List l= getWorld().getObjects(Healthsymbol.class);
            List m= getWorld().getObjects(Staminasymbol.class);
            List n= getWorld().getObjects(Speedsymbol.class);
            List o= getWorld().getObjects(Strengthsymbol.class);
            List p= getWorld().getObjects(addHealthsymbol.class);
            List q= getWorld().getObjects(addStaminasymbol.class);
            List r= getWorld().getObjects(deny_potion.class);
            getWorld().removeObjects(l);
            getWorld().removeObjects(m);
            getWorld().removeObjects(n);
            getWorld().removeObjects(o);
            getWorld().removeObjects(p);
            getWorld().removeObjects(q);
            getWorld().removeObjects(r);
        } 

        if(aenderung){
            h = getWorld().getObjects(Spacer.class);
            getWorld().removeObjects(h);     
            aenderung=false;
            java.util.List j;
            j = getWorld().getObjects(Overlay.class);
            getWorld().removeObjects(j);
            start=true;
            schaden=true;
            ausdauer=true;
        }  

        if(start){
            Corner corner = new Corner();
            Overlay o =new Overlay();
            getWorld().addObject(o,640,365);
            getWorld().addObject(corner,1215,75);
            int d =38;
            for(int x=0; x<6;x++){
                int c =43;
                Items i = itemGeben(x, 0);
                Items g = new Spacer(2,i.returnNumber(), i.seltenheitGeben());
                g.setImage("Spritze_"+x+".png");
                getWorld().addObject(g,d,c);
                d=d+70;
            }  
            Items[] ausgerListe = getAusger();
            for(int j = 0; j < ausgerListe.length;j++)
            {
                Items i = ausgerListe[j];
                switch(i.returnNumber())
                {
                    case 16: Trousers_L t_l = new Trousers_L(3, i.seltenheitGeben(), true);
                    getWorld().addObject(t_l, 0, 0); 
                    t_l.tragen(); 
                    break;
                    case 17: Chest_L c_l = new Chest_L(3, i.seltenheitGeben(), true);
                    getWorld().addObject(c_l, 0, 0); 
                    c_l.tragen(); 
                    break;
                    case 18: Helmet_L h_l = new Helmet_L(3, i.seltenheitGeben(), true);
                    getWorld().addObject(h_l, 0, 0); 
                    h_l.tragen(); 
                    break;
                    case 19: Trousers_M t_m = new Trousers_M(3, i.seltenheitGeben(), true);
                    getWorld().addObject(t_m, 0, 0); 
                    t_m.tragen(); 
                    break;
                    case 20: Chest_M c_m = new Chest_M(3, i.seltenheitGeben(), true);
                    getWorld().addObject(c_m, 0, 0); 
                    c_m.tragen(); 
                    break;
                    case 21: Helmet_M h_m = new Helmet_M(3, i.seltenheitGeben(), true);
                    getWorld().addObject(h_m, 0, 0); 
                    h_m.tragen(); 
                    break;
                    case 22: Trousers_H t_h = new Trousers_H(3, i.seltenheitGeben(), true);
                    getWorld().addObject(t_h, 0, 0); 
                    t_h.tragen(); 
                    break;
                    case 23: Chest_H c_h = new Chest_H(3, i.seltenheitGeben(), true);
                    getWorld().addObject(c_h, 0, 0); 
                    c_h.tragen(); 
                    break;
                    case 24: Helmet_H h_h = new Helmet_H(3, i.seltenheitGeben(), true);
                    getWorld().addObject(h_h, 0, 0); 
                    h_h.tragen(); 
                    break;
                }
            }
            start = false;
        } 
        int p=950;
        int l=950;
        if(schaden){
            h = getWorld().getObjects(Lebensteil.class);
            getWorld().removeObjects(h);
            for(int i=0;i<this.getlife();i++){
                if(i<10){
                    Lebensteil x= new Lebensteil();
                    getWorld().addObject(x,l,25);
                    l=l+20;
                }
                else{
                    Lebensteil x= new Lebensteil();
                    getWorld().addObject(x,p,25);
                    x.setImage("g_lebensteil2.png");
                    p=p+20;
                }
            }     
            schaden=false;
        }
        
        if(getlife()<=3&&getlife()>0){
            if(!heartbeat.isPlaying()){
                heartbeat.play();
            }
        }
        else{
            heartbeat.stop();
        }

        int q =950;
        int r=950;
        if(ausdauer){
            s = getWorld().getObjects(Ausdauerteil.class);
            getWorld().removeObjects(s);
            for(int j=0;j<this.getstamina();j++){
                if(j<10){
                    Ausdauerteil x= new Ausdauerteil();
                    getWorld().addObject(x,q,59);
                    q=q+20;
                }
                else{
                    Ausdauerteil x= new Ausdauerteil();
                    getWorld().addObject(x,r,59);
                    x.setImage("g_manateil2.png");
                    r=r+20;
                }
            }
            ausdauer=false;
        }              

        if(Greenfoot.isKeyDown("1")){
            if(numberhealth>0&&potiontimer>50){
                Health h = new Health(0);
                getWorld().addObject(h,200,-200);
                h.use();
                numberhealth--;
                potiontimer=0;
            }
            else{
                deny_potion g = new deny_potion();
                g.setImage("Spritze_0_f.png");
                getWorld().addObject(g,38,43);
                timer=50;
            }
        }

        if(Greenfoot.isKeyDown("2")){
            if(numberstamina>0&&potiontimer>50){
                Stamina s = new Stamina(0);
                getWorld().addObject(s,200,-200);
                s.use();
                numberstamina--;
                potiontimer=0;
            }
            else{
                deny_potion g = new deny_potion();
                g.setImage("Spritze_1_f.png");
                getWorld().addObject(g,108,43);
                timer=50;
            }
        }

        if(Greenfoot.isKeyDown("3")){
            if(numberspeed>0&&potiontimer>50){
                Speed h = new Speed(0);
                getWorld().addObject(h,200,-200);
                h.use();
                numberspeed--;
                potiontimer=0;
            }
            else{
                deny_potion g = new deny_potion();
                g.setImage("Spritze_2_f.png");
                getWorld().addObject(g,178,43);
                timer=50;
            }
        }

        if(Greenfoot.isKeyDown("4")){
            if(numberaddhealth>0&&potiontimer>50){
                add_health h = new add_health(0);
                getWorld().addObject(h,200,-200);
                h.use();
                numberaddhealth--;
                potiontimer=0;
            }
            else{
                deny_potion g = new deny_potion();
                g.setImage("Spritze_3_f.png");
                getWorld().addObject(g,248,43);
                timer=50;
            }
        }

        if(Greenfoot.isKeyDown("5")){
            if(numberaddstamina>0&&potiontimer>50){
                add_stamina h = new add_stamina(0);
                getWorld().addObject(h,200,-200);
                h.use();
                numberaddstamina--;
                potiontimer=0;
            }
            else{
                deny_potion g = new deny_potion();
                g.setImage("Spritze_4_f.png");
                getWorld().addObject(g,318,43);
                timer=50;
            }
        }

        if(Greenfoot.isKeyDown("6")){
            if(numberstrength>0&&potiontimer>50){
                add_strength h = new add_strength(0);
                getWorld().addObject(h,200,-200);
                h.use();
                numberstrength--;
                potiontimer=0;
            }
            else{
                deny_potion g = new deny_potion();
                g.setImage("Spritze_5_f.png");
                getWorld().addObject(g,388,43);
                timer=50;
            }
        }
        
    }
}
