import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

public class Speer extends Heavy_M
{
    private int number = 6;
    private GreenfootImage pic = new GreenfootImage("g.waffen_melee_Speer.png");
    private int timerTB = 0;
    private int timerMax = 5;
    private int x;
    private int y;
    private boolean direction = false;
    private int damage = 2;
    private int width = 33;
    private int height = -13;
    private int seltenheit;
    
    public Speer (int s)
    {
        super();
        statusSetzen(s);
        setImage(pic);
    }

    public Speer(int s, int seltenheit, boolean an)
    {
        super();
        setImage(pic);
        statusSetzen(s);
        this.seltenheit = seltenheit;
        super.an = an;
    }
    
    public void setX(int x)
    {
        this.x = x;
    }
    public void verschieben(int x, int y){
        setLocation(x,y);
    }
    public void setY(int y)
    {
        this.y = y;
    }
    public int getWidth(){
        return width;
    }
    public int getHeight(){
        return height;
    }

    

    public void act()
    {
    }
    public int getDamage(){
        return damage;
    }
    public int returnNumber()
    {
        return number;
    }
    
    public boolean touching(){
        return isTouching(HostilePhys.class);
    }
    public boolean touchingEnemy(){
        if(isTouching(HostilePhys.class)){
            return true;
        }
        else{
            return false;
        }
    }
    public void mirror()
    {
        pic.mirrorHorizontally();
    }
}
