import greenfoot.*;

public abstract class Subjects extends SmoothMover
{ 
 
    //Links - Rechts
    private double speed;
    private double currentSpeed;
    private double maxSpeed;

    private double exelaration;

    private double x;
    private double y;

    private int playerheight = 64;

    private int playerwidth = 32;

    //Hoch - Runter
    private double jumpHeight;
    private double currentJumpHeight;

    private double jumpSmoothener;

    private double gravity;
    private double currentGravity;

    private int jumpTimer;
    private int JumpExitTimer;

    private boolean preventJumping;
    private boolean inAir;
    private boolean firstAct;

    private Left l;
    private Right r;
    private Bottom b;
    private Top t;
    public Subjects(){
        speed = 1.0;
        maxSpeed = 5.0; 
        exelaration = 0.2; 

        jumpHeight = 7;
        currentJumpHeight = jumpHeight;
        jumpSmoothener = 0.2;

        gravity = 6;
        currentGravity = gravity;

        jumpTimer = 0;

        firstAct = true;
        preventJumping = true;

        jumpTimer = 10000;

        l = new Left();
        r = new Right();
        b = new Bottom();
        t = new Top();
    }

    public void act(){

        if(firstAct){

            World w = getWorld();

            w.addObject(l, getX() - 16, getY());
            w.addObject(r, getX() + 16, getY());
            w.addObject(t, getX(), getY() - 32);
            w.addObject(b, getX(), getY() + 32);
            firstAct = false;
        }
        else{
            

            moveHorizontal();

            
          

            moveBarriers();

        }
    }

    public void exelarate()
    {
        if(currentSpeed < maxSpeed){
            currentSpeed = currentSpeed + exelaration * currentSpeed;
        }
        else{
            currentSpeed = maxSpeed;
        }
    }

    public double get_X(){
        return x;
    }

    public double get_Y(){
        return y;
    }

    public void setLocation()

    {
        x = this.getX();
        y = this.getY();
    }

    public void moveHorizontal(){

        if(Greenfoot.isKeyDown("D"))
        {
            exelarate();

            for(double i = 0;i <= x; i = i+ 0.1){
                r.setLoc(r.getX2()+0.1,r.getY2());
                if(r.touching()){
                    currentSpeed = i;

                }
            }           
            super.setLocation(getX() + currentSpeed, getY());

        }

        if(Greenfoot.isKeyDown("A"))
        {

            exelarate();

            for(double y= 0 ; y<=x; y= y+0.1)
            {
                l.setLoc(l.getX2()-0.1,l.getY2());
                if(l.touching())
                {
                    currentSpeed = y;

                }

            }
            super.setLocation(getX()-currentSpeed, getY());

        }
        if(!(Greenfoot.isKeyDown("D")) && !(Greenfoot.isKeyDown("A"))){
            currentSpeed = speed;
        }

    }
   

  
    // Physik Barrieren

    public void moveBarriers(){
        l.setLocation(getX() - 16, getY());
        r.setLocation(getX() + 16, getY());
        t.setLocation(getX(), getY() - 32);
        b.setLoc(getExactX(), getExactY() + 32.1);
    }

}

